SUBROUTINE binomialcoeff(n, k, c)
    !#############################################################################
    ! calculates a binomial coeffitient
    !
    ! author: Florian Boecker   date: 21/12/2011
    ! http://complex-systems.uni-muenster.de/
    ! Licensing:  This code is distributed under the GNU GPL license.
    !
    ! parameters:
    !   name      i/o     datatype   description
    !   --------------------------------------------------------------------------
    !   n:        input   integer    - the total number of things
    !   k:        input   integer    - the number of things in each combination
    !   c:        output  integer    - the calculated binomial coeffitient
    !#############################################################################
    IMPLICIT NONE

    !Declaration
    INTEGER n   !the total number of things
    INTEGER k   !the number of things in each combination
    INTEGER c   !binomial coeffitient
    INTEGER mn  !size of smaller partition
    INTEGER mx  !size of lager partition
    INTEGER i   !loop controll

    !Calculation
    mn = MIN(k, n-k)
    IF(mn < 0)THEN
        c = 0
    ELSE
        IF(mn == 0)THEN
        c = 1
        ELSE
            mx = MAX(k, n-k)
            c = mx + 1
            DO i = 2, mn
                c = c * (mx + i) / i
            ENDDO
        ENDIF
    ENDIF

END SUBROUTINE binomialcoeff
