SUBROUTINE comb_part_enum(n, k, y, z, c)
    !#############################################################################
    ! comb_part returns the array comba with c combinations of k numbers in n positions
    ! differing to the original combination on up to z positions
    !
    ! author: Florian Boecker   date: 15/05/2011
    ! http://complex-systems.uni-muenster.de/
    ! Licensing:  This code is distributed under the GNU GPL license.
    !
    ! parameters:
    !   name      i/o     datatype   description
    !   --------------------------------------------------------------------------
    !   n:        input   integer    - the total number of things
    !   k:        input   integer    - the number of things in each combination
    !   y:        input   integer    - the minimum number of factors that should
    !                                  be new in every combination
    !   z:        input   integer    - the maximum number of factors that should
    !                                  be new in every combination
    !   c:        output  integer    - the number of combinations to be generated
    !#############################################################################

    !prevent implicite variable declaration
    IMPLICIT NONE

    !Declaration ##################################################################
    INTEGER i   !loop controll
    INTEGER n   !the total number of things
    INTEGER k   !the number of things in each combination
    INTEGER y   !the minimum number of factors that should be new in every combination
    INTEGER z   !the maximum number of factors that should be new in every combination
    INTEGER npart   !the number of parts
    INTEGER cpart   !the number of combinations per part
    INTEGER c   !the number of combinations to be generated

    ! Initialisation ##############################################################
    c = 1

    ! Calculation #################################################################
    DO i = y, z
        CALL binomialcoeff(k, i, npart) !number of parts
        CALL binomialcoeff(n-k, i, cpart) !number of combinations per part
        c = c + npart * cpart
    ENDDO

END SUBROUTINE comb_part_enum
