SUBROUTINE csv_record_append_re (value, record )

!*****************************************************************************80
!
!! CSV_RECORD_APPEND_I4 appends an I4 to a CSV record.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    24 November 2008
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) I4, the integer to be appended
!
!    Input/output, character ( len = * ) RECORD, the CSV record.
!
  implicit none

  REAL value
  CHARACTER ( len = 40 ) tmp
  integer   ( kind = 4 ) i
  character ( len = * )  record
!
!  Locate last used location in RECORD.
!
  i = len_trim ( record )
!
!  Append tab.
!
  if ( 0 < i ) then
    i = i + 1
    record(i:i) = CHAR(9)
  end if
!
!  Write re to RECORD.
!
  WRITE (tmp, '(F14.6)') value
  tmp = ADJUSTL(tmp)
  WRITE ( record(i+1:i+LEN_TRIM(TRIM(tmp))), '(a)' ) TRIM(tmp)

  return
end
