! ###############################################################
! linfit
!
!
! author: Eberhard Korsching   date: adapted on 16/04/2012
! http://complex-systems.uni-muenster.de/
! Licensing:  This code is distributed under the GNU GPL license.
! ###############################################################

SUBROUTINE linfit (x,y,nr,ssq)
    IMPLICIT NONE
    ! linear fit based on least square estimation - ssq in y ! - important for distribution
    INTEGER nr
    REAL x(nr), y(nr), nra, ei(nr), xbar, ybar, b, a, ssq
    nra = real(nr)
    xbar = sum(x)/nra !average
    ybar = sum(y)/nra !average
    ! estimator for b
    b = sum((x-xbar)*(y-ybar))/sum((x-xbar)**2)
    ! estimator for a
    a = ybar-b*xbar
    ! estimator for the theoretical residuals
    ei = y-a-b*x
    ! ei : distances from the fittingcourve to the original value - von der Fitgeraden aus gesehen bzgl. Vorzeichen (- nach unten, + nach oben)
    ssq = sum(ei**2)
END SUBROUTINE linfit
