SUBROUTINE readfile(filename, nrows, ncolumns, header, data)
!#############################################################################
! reads in a csv-file, returns its header in an one-dimensional
! character-array and its data in a real-array
!
! author: Florian Boecker   date: 25/10/2011
! http://complex-systems.uni-muenster.de/
! Licensing:  This code is distributed under the GNU GPL license.
!
! parameters:
!   name      i/o     datatype   description
!   --------------------------------------------------------------------------
!   filename: input   character  - the complete path of the file to be read in
!   nrows:    input   integer    - the number of rows in the file
!   ncolumns: input   integer    - the number of columns in the file
!   header:   output  character  - the labels of the columns,
!                                  read from the first row of the file
!   data:     ouput   real       - the data of the file in an array,
!                                  the RowNames in the first column is
!                                  converted to real
!#############################################################################
    IMPLICIT  NONE
    ! Declaration
    CHARACTER (len=100) :: filename
    CHARACTER (len=10) :: header(ncolumns), line(ncolumns)
    REAL :: data(nrows,ncolumns)
    INTEGER i, nrows, ncolumns
    INTEGER unitnumber
    CALL get_unit(unitnumber)
    ! Declares the datafile as unit 12
    OPEN(unit = unitnumber, file = filename)
    ! Read the header
    READ (unitnumber,*) header(:)
    ! Read in the Data
    DO i = 1, nrows
        ! Read in the Data as Character
        READ (unitnumber,*) line(:)
        ! Convert the Data to Real
        READ(line(:),*) data(i,:)
    ENDDO
    ! Close the File
    CLOSE (unitnumber)
END SUBROUTINE readfile
